#define BOOST_TEST_MODULE list_t test
#define BOOST_TEST_DYN_LINK
#define BOOST_TEST_MAIN

#define _SCL_SECURE_NO_WARNINGS

#include <boost/test/unit_test.hpp>

#include <string>
#include <vector>
#include <algorithm>
#include <limits>
#include <time.h>

#include "list_t.cpp"

using namespace boost;

const size_t test_size = 5;

BOOST_AUTO_TEST_CASE( test1 ) 
{
   list_t<int> a;  
   list_t<double> b;
   std::vector<int> v;
   srand(static_cast<unsigned>(clock()));
   for (size_t i = 0; i < test_size; ++i)
   {
      v.push_back(i);
   }
   list_t<int> c(v.begin(), v.end());
   BOOST_CHECK(std::equal(v.begin(), v.end(), c.begin()));
   list_t<int> d(c);
   BOOST_CHECK(c == d);
   BOOST_CHECK(c != a);
   list_t<int>::const_reverse_iterator iter1 = d.rend();
   for (int i = 0; i < test_size; ++i)
   {
      BOOST_CHECK_EQUAL(*(--iter1), i);
   }
   c.push_back(1);
   BOOST_CHECK(d < c);
   d.push_front(100);
   BOOST_CHECK(d > c);


   list_t<int> c1(c);
   list_t<int> d1(d);
   BOOST_CHECK_EQUAL(d1 > c1, d > c);
   
   c.swap(d);
   BOOST_CHECK(d < c);
   c.erase(c.begin());
   BOOST_CHECK(d > c);
   a.assign(v.begin(), v.end());
   BOOST_CHECK(a == c);



}

/*
BOOST_AUTO_TEST_CASE( second_test ) 
{

}
*/